

defaultSize     =   3;
defaultDensity  = 0.2;
defaultStrength =   1;


// TODO: write proper documentation about this!!!
//
// densitiy = 0…1
// strength = material thickness
// size = size of the generated infill volume
//   -> size is calculated as 10^size for each axis
//   -> therefore the generated volume includes at least the cube [10^size, 10^size, 10^size]


assertDensityMsg = "density out of range[ 0…1 ]";
assertStrengthMsg = "strength out of range[ > 0 ]";


// generates concentric vertival cylinders around the origin
module concentricCircleInfill(density=defaultDensity, strength=defaultStrength, size=defaultSize) {
  
  assert(strength > 0, assertStrengthMsg);
  assert(density > 0 && density <= 1, assertDensityMsg);
  
  linear_extrude(10^size) for (d=[0 : strength/density*2 : 10^size]) difference() {
    circle(d=d);
    circle(d=d - 2*strength);
  }
}



// generates straight lines along the X-axis
module lamellarInfill(density=defaultDensity, strength=defaultStrength, size=defaultSize) {

  assert(strength > 0, assertStrengthMsg);
  assert(density > 0 && density <= 1, assertDensityMsg);
  
  translate([0, -10^size/2, -10^size/2]) linear_extrude(10^size) for (ty=[0 : strength/density : 10^size]) translate([0, ty, 0]) square([10^size, strength], center=true);
}



module regularSpikeInfill(density=defaultDensity, strength=defaultStrength, size=defaultSize) {

  assert(strength > 0, assertStrengthMsg);
  assert(density > 0 && density <= 1, assertDensityMsg);  
  
  step = 2;  // TODO: do the math and calculate this appropriately!
  
  _size = (10^size) / 2;
  
  for (tx=[-_size:step:_size], ty=[-_size:step:_size]) translate([tx, ty, 0]) cylinder(d=strength, h=10^size, center=true);
}
